package org.eclipse.cosmos.rm.validation.internal.databuilders;

import java.util.Map;

import junit.framework.Test;

import org.eclipse.cosmos.rm.validation.internal.common.UtilityTester;
import org.eclipse.hyades.test.common.junit.DefaultTestArbiter;
import org.eclipse.hyades.test.common.junit.HyadesTestCase;
import org.eclipse.hyades.test.common.junit.HyadesTestSuite;

/**
 * Generated code for the test suite <b>TestElementTypeMapDataBuilder</b> located at
 * <i>/org.eclipse.cosmos.rm.validation.tests/junits/TestElementTypeMapDataBuilder.testsuite</i>.
 */
public class TestElementTypeMapDataBuilder extends HyadesTestCase
{
	/**
	 * Constructor for TestElementTypeMapDataBuilder.
	 * @param name
	 */
	public TestElementTypeMapDataBuilder(String name)
	{
		super(name);
	}

	/**
	 * Returns the JUnit test suite that implements the <b>TestElementTypeMapDataBuilder</b> definition.
	 */
	public static Test suite()
	{
		HyadesTestSuite testElementTypeMapDataBuilder = new HyadesTestSuite("TestElementTypeMapDataBuilder");
		testElementTypeMapDataBuilder.setArbiter(DefaultTestArbiter.INSTANCE).setId("EAE0EB6460661010BA242E707E6D11DB");
		testElementTypeMapDataBuilder.addTest(new TestElementTypeMapDataBuilder("testElementTypeMapGen").setId("EAE0EB6460661010BE41F4107E6D11DB").setTestInvocationId("EAE0EB6460661010C5E9CAD07E6D11DB"));
		return testElementTypeMapDataBuilder;
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception
	{
	}

	/**
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception
	{
	}

	/**
	 * testElementTypeMapGen
	 * @throws Exception
	 */
	public void testElementTypeMapGen() throws Exception
	{
		final String SML_IF_FILE = "test-resources/invalid-cycle.xml";
		ElementTypeMapDataBuilder elementTypeMapDataBuilder = new ElementTypeMapDataBuilder();		
		UtilityTester.parseDocument(this.getClass().getClassLoader().getResourceAsStream(SML_IF_FILE), elementTypeMapDataBuilder);
		
		Map inheritanceMap = (Map)elementTypeMapDataBuilder.getDataStructure();
		final String[][] EXPECTED_TYPES =  new String[][]{
				new String[] {"OptionalPreRequisite", "tns:OptionalCourseRefType"},
				new String[] {"RequiredPreRequisite", "tns:RequiredCourseRefType"},
		};
		
		for (int i = 0; i < EXPECTED_TYPES.length; i++)
		{
			assertEquals("The element: " + EXPECTED_TYPES[i][0] + " was expected to be of type: " + EXPECTED_TYPES[i][1],
					EXPECTED_TYPES[i][1],
					(String)inheritanceMap.get(EXPECTED_TYPES[i][0]));
		}
	}

}
